#include <stdio.h>
#include <stdlib.h>
#include <pwd.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include "main.h"
#include "getusers.h"
#include "Type.h"

//程序初始化//
int init(void)
{
	//忽略SIGINT和SIGQUIT信号//
	signal(SIGINT,SIG_IGN);
	signal(SIGQUIT,SIG_IGN);
	
	//给保存老的工作目录的指针分配空间//
	OldPath=malloc(PATHSIZE);
	if(OldPath == NULL)
	{
		perror("OldPath");
		return -1;
	}
	
	//给保存当前工作目录的指针分配空间//
	NowPath=malloc(PATHSIZE);
	if(NowPath == NULL)
	{
		perror("NowPath");
		return -1;
	}
	//取得当前的工作目录保存在 NowPath中//
	path_getcwd();
	
	
	//给保存程序名称和程序参数的指针分配空间//
	ProgramName=malloc(NAMESIZE);
	if(ProgramName == NULL)
	{
		perror("ProgramName");
		return -1;
	}
	ProgramParameter=malloc(PARAMETERSIZE);
	if(ProgramParameter == NULL)
	{
		perror("ProgramParameter");
		return -1;
	}

	
	//获取用户信息保存在users结构体中//
	get_users();
	
	//获取计算机名称保存到HostName中//
	get_host();
	
	//复制标准流的描述词保存在 SaveFlow中//
	get_flow();
	
	return 0;
}

//程序结束,清理占用的内存//
void clean(void)
{
	
	free(OldPath);
	free(NowPath);
	free(LineInput);
	free(ProgramName);
	free(ProgramParameter);

}
